
/**************************************************************************************************
 * Name          : PortalDelPatronPerfiles
 * Project       : Portal del patron
 * Description   : reporte de excedentes del imss
 * Table name    : 
 * Copyright     : Apsi 2009 - 2014. All rights reserved
 * Company       : APSI, S.A. De C.V.
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : jueves, 21 febrero 2012 
 **************************************************************************************************/

IF OBJECT_ID('dbo.PortalDelPatronPerfiles') IS NOT NULL 
    DROP PROCEDURE dbo.PortalDelPatronPerfiles
GO

CREATE PROCEDURE dbo.PortalDelPatronPerfiles

AS 
	BEGIN
	
	declare @existe int
	declare @idPerfil bigint
	DECLARE @existeSistema bigint		
	declare @usuario bigint	
	
	select @existeSistema=COUNT(sistema)
	from sistema
	where sistema='PP'
	
	if @existeSistema<=0
		begin
			insert into sistema(sistema,nombre) values('PP','Portal del Patron')
		end	
		
	select @existe=count(idperfil)
	from perfiles
	where sistema='PP'
	
	if @existe<=0 
		begin
		
		INSERT INTO perfiles (descripcion,sistema,empresas,nomina,actualizar,sueldo)
		 VALUES('Admin. Portal del Patron' ,'PP','{}','{}','N','S')

		insert into funciones (sistema,funcion,descripcion) values ('PP', 'A' , 'Informe Ejecutivo Nomina')	
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'B' , 'Informe Ejecutivo Otros')	
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'C' , 'Pasivo Laboral')	
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'D' , 'Reportes Varios')	
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'E' , 'Indices y Estadisticas')	
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'F' , 'Horas Laboradas')	
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'G' , 'Organigrama')	
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'H' , 'Historico Movimientos')
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'I' , 'Historico de Incidencias')					
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'J' , 'Auditoria de Sueldos')		
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'K' , 'Recibos de Nomina')		
		insert into funciones (sistema,funcion,descripcion) values ('PP', 'L' , 'Kardex')		
		insert into funciones (sistema,funcion,descripcion)	values ('PP', 'M' , 'Excedentes IMSS')		

		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('A1','PP', 'A', 'Informe Ejecutivo Nomina')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('B1','PP', 'B', 'Informe Ejecutivo Otros')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('C1','PP', 'C', 'Pasivo Laboral')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('D1','PP', 'D', 'Reportes Varios')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('E1','PP', 'E', 'Indices y Estadisticas')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('F1','PP', 'F', 'Horas Laboradas')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('G1','PP', 'G', 'Organigrama')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('H1','PP', 'H', 'Historico Movimientos')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('I1','PP', 'I', 'Historico de Incidencias')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('J1','PP', 'J', 'Auditoria de Sueldos')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('K1','PP', 'K', 'Recibos de Nomina')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('L1','PP', 'L', 'Kardex')           
		INSERT INTO opciones (opcion,sistema,funcion,descripcion) VALUES('M1','PP', 'M', 'Excedentes IMSS')                                                                                                                                    		                            
		
		select @idperfil=idperfil 
		from perfiles
		where sistema='PP' 
		and descripcion='Admin. Portal del Patron'
		
				
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('A','A1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('B','B1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('C','C1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('D','D1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('E','E1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('F','F1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('G','G1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('H','H1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('I','I1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('J','J1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('K','K1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('L','L1',@idperfil)
		INSERT INTO perfil_funcion (funcion,opcion,idperfil) VALUES('M','M1',@idperfil)
		
		select @usuario=COUNT(idperfil)
		from perfil_usuarios
		where idperfil= @idperfil
		and usuario='Administrador'
		
		
		 if @usuario<=0
			 begin
				insert into perfil_usuarios (idperfil, usuario) values (@idPerfil, 'Administrador')
			end
				
		end		
	
	END
  
GO

exec PortalDelPatronPerfiles
go


/**************************************************************************************************
 * Name          : EliminaPerfilPortalEmpresa
 * Project       : Portal del patron
 * Description   : reporte de excedentes del imss
 * Table name    : 
 * Copyright     : Apsi 2009 - 2014. All rights reserved
 * Company       : APSI, S.A. De C.V.
 * Author        : Mario Garcia (mario.garcia@apsi.com.mx)
 * Creation date : jueves, 21 febrero 2012 
 **************************************************************************************************/

IF OBJECT_ID('dbo.EliminaPerfilPortalEmpresa') IS NOT NULL 
    DROP PROCEDURE dbo.EliminaPerfilPortalEmpresa
GO

CREATE PROCEDURE dbo.EliminaPerfilPortalEmpresa

AS 
	BEGIN
	
	declare @idPerfil bigint
	DECLARE @existeSistema bigint		
	
	select @idperfil=p.idperfil
	from perfil_funcion pf, perfiles p
	where p.sistema='PE'
	and pf.idperfil=p.idperfil
		
	
	delete from opciones where sistema='PE'
	delete from funciones where sistema='PE'
	
	delete from perfil_funcion where idperfil in (select p.idperfil
													from perfil_funcion pf, perfiles p
													where p.sistema='PE'
													and pf.idperfil=p.idperfil)
													
	delete from perfil_usuarios where idperfil in (select idperfil from perfiles where sistema='PE')																							
	delete from ie_us_accesos where sistema='PE'										
	delete from Sistema where sistema='PE'		
	
	end
  
GO

exec EliminaPerfilPortalEmpresa
go

