

IF NOT EXISTS ( SELECT  1
                FROM    systypes
                WHERE   name = 'udtStringSize15' ) 
    CREATE TYPE udtStringSize15 FROM VARCHAR(15)
GO
IF NOT EXISTS ( SELECT  syscolumns.name
                FROM    syscolumns
                        LEFT JOIN sysobjects ON syscolumns.id = sysobjects.id
                WHERE   syscolumns.name = 'RutaDoc'
                        AND sysobjects.name = 'rhrel_requisitos' ) 
    ALTER TABLE rhrel_requisitos ADD RutaDoc VARCHAR(200)
GO
/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */ 
/*  *  *  *  *  *						Stored procedures for indicators	 		    *  *  *  *  *  *  */ 
/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */ 
GO
/**************************************************************************************************
 * Name          : PortalPatronGetMonthIndicators
 * Project       : Portal del patron
 * Description   : Extrae los indicadores de un rando de fechas
 * Table name    : 
 * Copyright     : Apsi 2009 - 2014. All rights reserved
 * Company       : APSI, S.A. De C.V.
 * Author        : Angel Fernando Lopez Vazquez (angel.lopez@apsi.com.mx)
 * Creation date : Martes, 21 de Julio 2011 
 **************************************************************************************************/
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronGetMonthIndicators')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronGetMonthIndicators

GO
CREATE PROCEDURE dbo.PortalPatronGetMonthIndicators
    (
      @fechaInicio udtDateTime ,
      @fechatermino udtDateTime ,
      @llave udtLong
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    IF ( SELECT COUNT(a.codigo)
         FROM   dbo.avisos_imss AS a
         WHERE  a.mov IN ( 'A', 'IM', 'RI' )
                AND a.fch_mov BETWEEN @fechaInicio AND @fechatermino
                AND a.empresa IN ( SELECT   empresa
                                   FROM     tmpAccesoPortalPatron
                                   WHERE    Llave = @llave )
                AND a.serial = 1
       ) = 0 
        BEGIN
            SELECT  0 AS mes ,
                    0 AS empIniMes ,
                    0 AS empActual ,
                    0 AS empTotMes ,
                    0 AS altas ,
                    0 AS bajas ,
                    0 AS rotacion1 ,
                    0 AS rotacion2 ,
                    0 AS ms ,
                    0 AS msxvar ,
                    0 AS faltas ,
                    0 AS incap ,
                    0 AS totAus ,
                    0 AS diaslLab ,
                    0 AS Ind_Aus ,
                    0 AS te ,
                    0 AS sueldo ,
                    0 AS porcTe ,
                    0 AS hrsTe ,
                    0 AS perEquiv ,
                    0 AS LabDiaDesc ,
                    0 AS LabDiaDescPor ,
                    0 AS hrsLabDiaDesc
        END
    ELSE 
        BEGIN   

            DECLARE @tmp_Indicadores_Detalle_emps TABLE
                (
                  empresa INT ,
                  empsIm NUMERIC(10, 2) ,
                  empsAct NUMERIC(10, 2) ,
                  ms NUMERIC(10, 2) ,
                  altas NUMERIC(10, 2) ,
                  bajas NUMERIC(10, 2) ,
                  msxvar NUMERIC(10, 2) ,
                  ri NUMERIC(10, 2) ,
                  empsmes NUMERIC(10, 2)
                )
            DECLARE @tmp_Indicadores_Detalle_dias TABLE
                (
                  empresa INT ,
                  dias NUMERIC(10, 2)
                )

            DECLARE @tmp_Indicadores_Detalle_ausen TABLE
                (
                  empresa INT ,
                  faltas NUMERIC(10, 2) ,
                  incapacidades NUMERIC(10, 2)
                )
            DECLARE @tmp_Indicadores_Detalle_TExtra TABLE
                (
                  empresa INT ,
                  imp_sueldos NUMERIC(10, 2) ,
                  hrs_sueldos NUMERIC(10, 2) ,
                  imp_TE NUMERIC(10, 2) ,
                  hrs_TE NUMERIC(10, 2) ,
                  imp_Faltas NUMERIC(10, 2) ,
                  hrs_Faltas NUMERIC(10, 2) ,
                  imp_LabDes NUMERIC(10, 2) ,
                  hrs_LabDes NUMERIC(10, 2)
                )

             	    					 
            INSERT  INTO @tmp_Indicadores_Detalle_emps
                    ( empsIM ,
                      empsAct ,
                      empsmes ,
                      altas ,
                      bajas ,
                      ms ,
                      msxvar ,
                      ri ,
                      empresa                      
                    )
                    SELECT  SUM(CASE a.mov
                                  WHEN 'IM' THEN 1
                                  ELSE 0
                                END) AS empIm ,
                            0 AS empActual ,
                            SUM(CASE a.mov
                                  WHEN 'IM' THEN 1
                                  WHEN 'A' THEN 1
                                  ELSE 0
                                END) AS emptot ,
                            SUM(CASE a.mov
                                  WHEN 'A' THEN 1
                                  ELSE 0
                                END) AS altas ,
                            SUM(CASE a.mov
                                  WHEN 'B' THEN 1
                                  ELSE 0
                                END) AS bajas ,
                            SUM(CASE a.mov
                                  WHEN 'MS' THEN 1
                                  ELSE 0
                                END) AS ms ,
                            SUM(CASE a.mov
                                  WHEN 'MS'
                                  THEN ( CASE WHEN origen = 'V' THEN 1
                                              ELSE 0
                                         END )
                                  ELSE 0
                                END) AS msxvar ,
                            SUM(CASE a.mov
                                  WHEN 'RI' THEN 1
                                  ELSE 0
                                END) AS ri ,
                            a.empresa
                    FROM    dbo.avisos_imss AS a
                    WHERE   a.mov IN ( 'A', 'IM', 'B', 'MS', 'RI' )
                            AND a.fch_mov BETWEEN @fechaInicio AND @fechatermino
                            AND a.empresa IN ( SELECT   empresa
                                               FROM     tmpAccesoPortalPatron
                                               WHERE    Llave = @llave )
                    GROUP BY a.empresa
                    
            UPDATE  @tmp_Indicadores_Detalle_emps
            SET     bajas= bajas - ri
                    
            UPDATE  @tmp_Indicadores_Detalle_emps
            SET     empsAct = empsmes - bajas
                                       
            INSERT  INTO @tmp_Indicadores_Detalle_dias
                    ( empresa ,
                      dias
                    )
                    SELECT  a.empresa ,
                            CASE WHEN ( SELECT  SUM(1)
                                        FROM    dbo.avisos_imss
                                        WHERE   empresa = a.empresa
                                                AND codigo = a.codigo
                                                AND fch_mov BETWEEN @fechaInicio AND @fechatermino
                                                AND mov = 'B'
                                      ) >= 1
                                      AND a.mov = 'IM' THEN 0
                                 WHEN ISNULL(( SELECT   SUM(1)
                                               FROM     dbo.avisos_imss
                                               WHERE    empresa = a.empresa
                                                        AND codigo = a.codigo
                                                        AND fch_mov BETWEEN @fechaInicio AND @fechatermino
                                                        AND mov = 'B'
                                             ), 0) = 0
                                      AND a.mov = 'IM'
                                 THEN DATEDIFF(day, a.fch_mov, @fechaTermino)
                                      + 1
                                 WHEN a.mov = 'A'
                                 THEN DATEDIFF(day, a.fch_mov, @fechaTermino)
                                 WHEN a.mov = 'RI'
                                 THEN DATEDIFF(day, a.fch_mov, @fechaTermino)
                                 WHEN a.mov = 'B'
                                 THEN DATEDIFF(day, @fechaInicio, a.fch_mov)
                                      + 1
                            END AS dias
                    FROM    dbo.avisos_imss AS a
                    WHERE   a.fch_mov BETWEEN @fechaInicio AND @fechatermino
                            AND a.mov <> 'MS'
                            AND a.empresa IN ( SELECT   empresa
                                               FROM     tmpAccesoPortalPatron
                                               WHERE    Llave = @llave )
                    ORDER BY a.codigo ,
                            a.serial
	
            INSERT  INTO @tmp_Indicadores_Detalle_ausen
                    ( empresa ,
                      faltas ,
                      incapacidades
                    )
                    SELECT  empresa ,
                            SUM(CASE num_conc
                                  WHEN 108
                                  THEN DATEDIFF(DD,
                                                CASE WHEN fchinicio < @fechaInicio
                                                     THEN @fechaInicio
                                                     ELSE fchinicio
                                                END,
                                                CASE WHEN fchtermino > @fechatermino
                                                     THEN @fechatermino
                                                     ELSE fchtermino
                                                END) + 1
                                  ELSE 0
                                END) AS faltas ,
                            SUM(CASE num_conc
                                  WHEN 108 THEN 0
                                  ELSE DATEDIFF(DD,
                                                CASE WHEN fchinicio < @fechaInicio
                                                     THEN @fechaInicio
                                                     ELSE fchinicio
                                                END,
                                                CASE WHEN fchtermino > @fechatermino
                                                     THEN @fechatermino
                                                     ELSE fchtermino
                                                END) + 1
                                END) AS incapacidades
                    FROM    deducciones
                    WHERE   num_conc IN ( 108, 109, 110, 111 )
                            AND ( ( fchinicio BETWEEN @fechaInicio AND @fechatermino )
                                  OR ( fchtermino BETWEEN @fechaInicio AND @fechatermino )
                                  OR ( fchinicio < @fechaInicio
                                       AND fchtermino > @fechatermino
                                     )
                                )
                            AND empresa IN ( SELECT empresa
                                             FROM   tmpAccesoPortalPatron
                                             WHERE  Llave = @llave )
                    GROUP BY empresa                    
DECLARE @mesFiltro VARCHAR(5)
SELECT  @mesFiltro = CASE MONTH(@fechainicio)
                       WHEN 1 THEN 'ENE'
                       WHEN 2 THEN 'FEB'
                       WHEN 3 THEN 'MAR'
                       WHEN 4 THEN 'ABR'
                       WHEN 5 THEN 'MAY'
                       WHEN 6 THEN 'JUN'
                       WHEN 7 THEN 'JUL'
                       WHEN 8 THEN 'AGO'
                       WHEN 9 THEN 'SEP'
                       WHEN 10 THEN 'OCT'
                       WHEN 11 THEN 'NOV'
                       WHEN 12 THEN 'DIC'
                     END+ SUBSTRING(CAST(YEAR(@fechainicio) AS CHAR(4)),3,2)
--PRINT @mesFiltro   

            INSERT  INTO @tmp_Indicadores_Detalle_TExtra
                    ( empresa ,
                      imp_sueldos ,
                      hrs_sueldos ,
                      imp_TE ,
                      hrs_TE ,
                      imp_Faltas ,
                      hrs_Faltas ,
                      imp_LabDes ,
                      hrs_LabDes
                    )
                    SELECT  a.empresa ,
                            SUM(CASE WHEN a.num_conc < 7 THEN a.importe
                                     ELSE 0
                                END) AS imp_sueldos ,
                            SUM(CASE WHEN a.num_conc < 7 THEN a.horas
                                     ELSE 0
                                END) AS hrs_sueldos ,
                            SUM(CASE WHEN a.num_conc > 10
                                          AND a.num_conc < 14 THEN a.importe
                                     ELSE 0
                                END) AS imp_TE ,
                            SUM(CASE WHEN a.num_conc > 10
                                          AND a.num_conc < 14 THEN a.horas
                                     ELSE 0
                                END) AS hrs_TE ,
                            SUM(CASE WHEN a.num_conc > 107
                                          AND a.num_conc < 112 THEN a.importe
                                     ELSE 0
                                END) AS imp_Faltas ,
                            SUM(CASE WHEN a.num_conc > 107
                                          AND a.num_conc < 112 THEN a.horas
                                     ELSE 0
                                END) AS hrs_Faltas ,
                            SUM(CASE WHEN a.num_conc = 10 THEN a.importe
                                     ELSE 0
                                END) AS imp_LabDes ,
                            SUM(CASE WHEN a.num_conc = 10 THEN a.horas
                                     ELSE 0
                                END) AS hrs_LabDes
                    FROM    dbo.kardex_anual AS a
                            JOIN tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                                                              AND b.llave = @llave
                    WHERE   a.num_conc IN ( 1, 2, 3, 4, 5, 6, 10, 11, 12, 13,
                                            108, 109, 110, 111 )
							AND a.mes=@mesFiltro                                             
--                            AND a.fch_pago BETWEEN @fechaInicio AND @fechatermino
--                            AND a.nomina = 'ORD'
                    GROUP BY a.empresa                    

            SELECT  MONTH(@fechaInicio) AS mes ,
                    a.empsim AS empIniMes ,
                    a.empsAct AS empActual ,
                    a.empsmes AS empTotMes ,
                    ISNULL(a.altas, 0) AS altas ,
                    ISNULL(a.bajas, 0) AS bajas ,
                    ( ( ISNULL(a.altas, 0) - ISNULL(a.bajas, 0) ) / a.empsmes )
                    * 100 AS rotacion1 ,
                    ( ISNULL(a.bajas, 0) / a.empsmes ) * 100 AS rotacion2 ,
                    ISNULL(a.ms, 0) AS ms ,
                    ISNULL(a.msxvar, 0) AS msxvar ,
                    ISNULL(f.faltas, 0) AS faltas ,
                    ISNULL(f.incapacidades, 0) AS incap ,
                    ISNULL(f.faltas, 0) + ISNULL(f.incapacidades, 0) AS totAus ,
                    g.dias - ( ISNULL(f.faltas, 0) + ISNULL(f.incapacidades, 0) ) AS diaslLab ,
                    ( ( ISNULL(f.faltas, 0) + ISNULL(f.incapacidades, 0) )
                      / ( g.dias ) ) * 100 AS Ind_Aus ,
                    ISNULL(te.imp_te, 0) AS te ,
                    ISNULL(te.imp_sueldos, 0) - ISNULL(te.imp_faltas, 0) AS sueldo ,
                    CASE ISNULL(te.imp_te, 0)
                      WHEN 0 THEN 0
                      ELSE ( ISNULL(te.imp_te, 0) * 100 )
                           / ( ISNULL(te.imp_sueldos, 0)
                               - ISNULL(te.imp_faltas, 0) )
                    END AS porcTe ,
                    ISNULL(te.hrs_te, 0) AS hrsTe ,
                    ( ISNULL(te.hrs_te, 0) / 30.4 ) / 8 AS perEquiv ,
                    ISNULL(te.imp_LabDes, 0) AS LabDiaDesc ,
                    CASE ISNULL(te.imp_LabDes, 0)
                      WHEN 0 THEN 0
                      ELSE ( ISNULL(te.imp_LabDes, 0)
                             / ( ISNULL(te.imp_sueldos, 0)
                                 - ISNULL(te.imp_faltas, 0) ) ) * 100
                    END AS LabDiaDescPor ,
                    ISNULL(te.hrs_LabDes, 0) AS hrsLabDiaDesc
            FROM    @tmp_Indicadores_Detalle_emps AS a
                    LEFT JOIN @tmp_Indicadores_Detalle_ausen AS f ON a.empresa = f.empresa
                    LEFT JOIN ( SELECT  empresa ,
                                        SUM(dias) AS dias
                                FROM    @tmp_Indicadores_Detalle_dias
                                GROUP BY empresa
                              ) AS g ON a.empresa = g.empresa
                    LEFT JOIN @tmp_Indicadores_Detalle_TExtra AS te ON a.empresa = te.empresa
        END 
GO                                                        
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronGetTotalIndicatorsMensuales')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronGetTotalIndicatorsMensuales
GO
CREATE PROCEDURE dbo.PortalPatronGetTotalIndicatorsMensuales
    (
      @ayo NUMERIC(4, 0) ,
      @llave udtLong ,
      @columnaGraficar NUMERIC(2, 0) = 1
    )
AS 
    SET NOCOUNT ON
    DECLARE @tmp_Indicadores_totales TABLE
        (
          mes INT ,
          emp_inicio_mes NUMERIC(10, 2) ,
          empa_fin_mes NUMERIC(10, 2) ,
          emp_totales_mes NUMERIC(10, 2) ,
          altas NUMERIC(10, 2) ,
          bajas NUMERIC(10, 2) ,
          rotacion1 NUMERIC(10, 4) ,
          rotacion2 NUMERIC(10, 4) ,
          mod_salario NUMERIC(10, 2) ,
          mod_salario_x_variables NUMERIC(10, 2) ,
          faltas NUMERIC(10, 2) ,
          incapacidades NUMERIC(10, 2) ,
          aucentismo_total NUMERIC(10, 2) ,
          dias_laborados NUMERIC(10, 2) ,
          ind_auscentismo NUMERIC(12, 4) ,
          tiempo_extra NUMERIC(12, 2) ,
          sueldos NUMERIC(12, 2) ,
          porcentaje_tiempoextra NUMERIC(12, 2) ,
          horas_tiempoextra NUMERIC(12, 2) ,
          personal_equivalente NUMERIC(12, 2) ,
          labores_dia_descanso NUMERIC(12, 2) ,
          porcentaje_labores_dia_descanso NUMERIC(12, 2) ,
          horas_labores_dia_descanso NUMERIC(12, 2)
        )
    DECLARE @Mes NUMERIC(2, 0)
    DECLARE @mesOperacion NUMERIC(2, 0)
    DECLARE @fechainicial DATETIME
    DECLARE @fechafinal DATETIME
    SET @Mes = 1
    SET @mesoperacion = 1
    
    SELECT @mesoperacion = MAX(a.mes_operacion) FROM empresas AS a
    JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa=b.empresa
    WHERE b.llave=@llave AND a.ayo_operacion=@ayo
    
    Select @mesoperacion=ISNULL(@mesoperacion,12 )
    
    WHILE @Mes <= @mesOperacion 
        BEGIN
            SET @fechainicial = CAST(@ayo AS VARCHAR(4)) + REPLACE(STR(@mes, 2),
                                                              ' ', '0') + '01'
            SET @fechafinal = CAST(CASE WHEN @mes + 1 > 12 THEN @ayo + 1
                                        ELSE @ayo
                                   END AS VARCHAR(4))
                + REPLACE(STR(CASE WHEN @mes + 1 > 12 THEN 1
                                   ELSE @mes + 1
                              END, 2), ' ', '0') + '01'	
            SET @fechafinal = @fechafinal - 1                  
            
            INSERT  INTO @tmp_Indicadores_totales
                    EXEC PortalPatronGetMonthIndicators @fechainicial,
                        @fechafinal, @llave
            SET @Mes = @Mes + 1
            
        END

    SELECT  CASE mes
              WHEN 1 THEN '01-ENERO'
              WHEN 2 THEN '02-FEBRERO'
              WHEN 3 THEN '03-MARZO'
              WHEN 4 THEN '04-ABRIL'
              WHEN 5 THEN '05-MAYO'
              WHEN 6 THEN '06-JUNIO'
              WHEN 7 THEN '07-JULIO'
              WHEN 8 THEN '08-AGOSTO'
              WHEN 9 THEN '09-SEPTIEMBRE'
              WHEN 10 THEN '10-OCTUBRE'
              WHEN 11 THEN '11-NOVIEMBRE'
              WHEN 12 THEN '12-DICIEMBRE'
            END AS mes ,
            SUM(emp_inicio_mes) AS emp_inicio_mes ,
            SUM(empa_fin_mes) AS empa_fin_mes ,
            SUM(emp_totales_mes) AS emp_totales_mes ,
            SUM(altas) AS altas ,
            SUM(bajas) AS bajas ,
            ( SUM(altas) - SUM(bajas) ) / SUM(emp_totales_mes) * 100 AS rotacion1 ,
            SUM(bajas) / SUM(emp_totales_mes) * 100 AS rotacion2 ,
            SUM(mod_salario) AS mod_salario ,
            SUM(mod_salario_x_variables) AS mod_salario_x_variables ,
            SUM(faltas) AS faltas ,
            SUM(incapacidades) AS incapacidades ,
            SUM(aucentismo_total) AS aucentismo_total ,
            SUM(dias_laborados) AS dias_laborados ,
            SUM(ind_auscentismo) AS ind_auscentismo ,
            SUM(tiempo_extra) AS tiempo_extra ,
            SUM(sueldos) AS sueldos ,
            SUM(porcentaje_tiempoextra) AS porcentaje_tiempoextra ,
            SUM(horas_tiempoextra) AS horas_tiempoextra ,
            SUM(personal_equivalente) AS personal_equivalente ,
            SUM(labores_dia_descanso) AS labores_dia_descanso ,
            SUM(porcentaje_labores_dia_descanso) AS porcentaje_labores_dia_descanso ,
            SUM(horas_labores_dia_descanso) AS horas_labores_dia_descanso ,
            CASE @columnaGraficar
              WHEN 1 THEN 0
              WHEN 2 THEN SUM(emp_inicio_mes)
              WHEN 3 THEN SUM(empa_fin_mes)
              WHEN 4 THEN SUM(emp_totales_mes)
              WHEN 5 THEN SUM(altas)
              WHEN 6 THEN SUM(bajas)
              WHEN 7
              THEN ( SUM(altas) - SUM(bajas) ) / SUM(emp_totales_mes) * 100
              WHEN 8 THEN SUM(bajas) / SUM(emp_totales_mes) * 100
              WHEN 9 THEN SUM(mod_salario)
              WHEN 10 THEN SUM(mod_salario_x_variables)
              WHEN 11 THEN SUM(faltas)
              WHEN 12 THEN SUM(incapacidades)
              WHEN 13 THEN SUM(aucentismo_total)
              WHEN 14 THEN SUM(dias_laborados)
              WHEN 15 THEN SUM(ind_auscentismo)
              WHEN 16 THEN SUM(tiempo_extra)
              WHEN 17 THEN SUM(sueldos)
              WHEN 18 THEN SUM(porcentaje_tiempoextra)
              WHEN 19 THEN SUM(horas_tiempoextra)
              WHEN 20 THEN SUM(personal_equivalente)
              WHEN 21 THEN SUM(labores_dia_descanso)
              WHEN 22 THEN SUM(porcentaje_labores_dia_descanso)
              WHEN 23 THEN SUM(horas_labores_dia_descanso)
            END AS grafiar ,
            ( SELECT    COUNT(*)
              FROM      @tmp_Indicadores_totales
              WHERE     mes > 0
            ) AS recordsCount
    FROM    @tmp_Indicadores_totales
    WHERE   mes > 0
    GROUP BY mes
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronGetReasonLow')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronGetReasonLow

GO
CREATE PROCEDURE dbo.PortalPatronGetReasonLow
    (
      @mes_operacion udtInteger ,
      @ayo_operacion udtInteger ,
      @llave udtLong
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SET DATEFORMAT MDY
    DECLARE @TotalRecords NUMERIC(8, 0)
    DECLARE @condicion VARCHAR(2000)
    DECLARE @select VARCHAR(2000)
    SET @TotalRecords = 0
    SET @condicion = ''
 
    IF @mes_operacion < 13
        OR @mes_operacion > 0 
        SET @condicion = ' AND a.mes_operacion = ' + STR(@mes_operacion)
	 
    SET @select = 'SELECT  count(a.mot_baja)
    FROM    avisos_imss AS a
            LEFT JOIN rh_motivosbaja AS b ON a.clave_baja = b.idbaja
            JOIN tmpAccesoPortalPatron AS c ON a.empresa = c.empresa
    WHERE   a.ayo_operacion = ' + STR(@ayo_operacion) + @condicion + '
            AND a.mov = ''B''
            AND c.Llave = ' + STR(@llave) + '
    GROUP BY a.clave_baja ,
            a.mot_baja'                        

    CREATE TABLE #RecorsdFound ( TotalRecords INTEGER )
        
    INSERT  INTO #RecorsdFound
            EXECUTE ( @select
                   )
        -- Set the total records indicador
    SELECT TOP 1
            @TotalRecords = COUNT(TotalRecords)
    FROM    #RecorsdFound
    SET @totalRecords = ISNULL(@totalRecords, 0)
        
    DROP TABLE #RecorsdFound
 
    SET @select = 'SELECT  a.clave_baja ,
            a.mot_baja as motivo,
            COUNT(a.mot_baja) AS recordsCount,
            ' + STR(@TotalRecords) + ' AS recordsFounds
    FROM    avisos_imss AS a
            LEFT JOIN rh_motivosbaja AS b ON a.clave_baja = b.idbaja
            JOIN tmpAccesoPortalPatron AS c ON a.empresa = c.empresa
    WHERE   a.ayo_operacion = ' + STR(@ayo_operacion) + @condicion + '
            AND a.mov = ''B''
            AND c.Llave = ' + STR(@llave) + '
    GROUP BY a.clave_baja ,
            a.mot_baja'                        
            
    IF @TotalRecords > 0 
        EXECUTE (@select)
    ELSE 
                SELECT  0 AS clave_baja,'NO EXISTEN BAJAS' AS motivo,0 AS recordsCount,0 AS recordsFounds
            
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronGetAgeIndicators')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronGetAgeIndicators

GO
CREATE PROCEDURE dbo.PortalPatronGetAgeIndicators ( @llave udtLong )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  DATEDIFF(year, a.fchnac, GETDATE()) AS edades ,
            COUNT(a.sexo) AS empleados ,
            COUNT(CASE a.sexo
                    WHEN 'M' THEN a.sexo
                    ELSE NULL
                  END) AS hombres ,
            COUNT(CASE a.sexo
                    WHEN 'F' THEN a.sexo
                    ELSE NULL
                  END) AS Mujeres
    FROM    empleados AS a
            JOIN tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
    WHERE   a.activo = 'S'
            AND b.llave = @llave
    GROUP BY DATEDIFF(year, a.fchnac, GETDATE())
    ORDER BY DATEDIFF(year, a.fchnac, GETDATE())            
GO             
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronGetWageIndicators')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronGetWageIndicators
GO
CREATE PROCEDURE dbo.PortalPatronGetWageIndicators
    (
      @mes_operacion udtInteger ,
      @ayo_operacion udtInteger ,
      @llave udtLong 
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  a.Sueldo ,
            COUNT(c.codigo) AS cuantos
    FROM    avisos_imss a
            JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
            JOIN ( SELECT   empresa ,
                            codigo ,
                            MAX(x.serial) AS serial
                   FROM     avisos_imss AS x
                   WHERE    x.mov <> 'B'
                            AND x.ayo_operacion = @ayo_operacion
                            AND x.mes_operacion = @mes_operacion
                   GROUP BY empresa ,
                            codigo
                 ) AS c ON a.empresa = c.empresa
                           AND a.codigo = c.codigo
                           AND a.serial = c.serial
    WHERE   a.mes_operacion = @mes_operacion
            AND a.ayo_operacion = @ayo_operacion
            AND b.llave = @llave
    GROUP BY sueldo
    ORDER BY Sueldo 
GO        
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronGetOccupationalIndicators')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronGetOccupationalIndicators

GO
CREATE PROCEDURE dbo.PortalPatronGetOccupationalIndicators
    (
      @mes udtInteger ,
      @ayo udtInteger ,
      @llave udtLong
    )
    --WITH ENCRYPTION
AS 
    SET NOCOUNT ON

    DECLARE @conditionMes udtStringSize128
    SET @conditionMes = ''
    IF @mes > 0
        AND @mes < 13 
        SET @conditionMes = 'a.mes_operacion=' + CAST(@mes AS VARCHAR(2))
            + ' and '

    DECLARE @Select udtStringSize4096
    DECLARE @debugFlag udtByte
    DECLARE @Select2 udtStringSize4096
    SET @debugFlag = 0
    
    DECLARE @tmp_Indicadores_ocupacion TABLE
        (
          actividad udtName ,
          cuantos NUMERIC(10, 2)
        )
    
    SET @Select = ' SELECT  c.actividad ,COUNT(DISTINCT ( a.codigo )) as empleados
				  FROM    avisos_imss AS a
				  LEFT JOIN llaves AS b ON a.empresa = b.empresa
                                 AND a.codigo = b.codigo
				  LEFT JOIN tabulador AS c ON b.ocupacion = c.ocupacion
                                    AND b.empresa = c.empresa
                  JOIN tmpAccesoPortalPatron as d on a.empresa=d.empresa
				  WHERE    ' + RTRIM(LTRIM(@conditionMes))
        + ' a.ayo_operacion = ' + RTRIM(LTRIM(STR(@ayo)))
        + ' AND a.codigo NOT IN ( SELECT    f.codigo
										      FROM      Historico AS f
											  WHERE     f.campo = ''TABULADOR''
											  AND f.empresa = a.empresa
                                              AND f.mes_operacion = a.mes_operacion
                                              AND f.ayo_operacion = a.ayo_operacion ) 
                                              AND d.llave= '
        + RTRIM(LTRIM(STR(@llave))) + ' GROUP BY c.actividad'
                                              
    SET @Select2 = 'Select c.actividad,Count(Distinct(a.codigo)) as empleados from historico as a 
 left join tabulador as c on a.valor_original=c.ocupacion and a.empresa=c.empresa 
 JOIN tmpAccesoPortalPatron as d on a.empresa=d.empresa
 where  ' + RTRIM(LTRIM(@conditionMes)) + '  a.ayo_operacion='
        + RTRIM(LTRIM(@ayo))
        + '  and a.codigo in 
 (Select f.codigo from Historico as f where f.campo=''TABULADOR'' and f.empresa=a.empresa and f.mes_operacion=a.mes_operacion and f.ayo_operacion= a.ayo_operacion)  
 AND a.campo = ''TABULADOR'' AND d.llave=' + RTRIM(LTRIM(STR(@llave))) + ' Group by c.actividad'
    IF @debugFlag = 1 
        SELECT  @Select + ' union ' + @Select2 
    ELSE 
        INSERT  INTO @tmp_Indicadores_ocupacion
                EXECUTE ( @Select + ' union ' + @Select2
                       )                                              
                                              
    SELECT  actividad ,
            SUM(cuantos) AS empleados
    FROM    @tmp_Indicadores_ocupacion
    GROUP BY actividad
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.ObtenIndicadoresCentros')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.ObtenIndicadoresCentros

GO

CREATE PROCEDURE dbo.ObtenIndicadoresCentros
    (
      @fechaInicio udtDateTime ,
      @fechatermino udtDateTime ,
      @llave udtLong ,
      @columnaGraficar udtInteger
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON

    IF NOT EXISTS ( SELECT  *
                    FROM    dbo.avisos_imss AS a
                            JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                    WHERE   a.mov IN ( 'A', 'IM', 'RI' )
                            AND a.fch_mov BETWEEN @fechaInicio AND @fechatermino
                            AND a.serial = 1
                            AND b.llave = @llave ) 
        BEGIN
            SELECT  0 AS mes ,
                    0 AS empIniMes ,
                    0 AS empActual ,
                    0 AS empTotMes ,
                    0 AS altas ,
                    0 AS bajas ,
                    0 AS rotacion1 ,
                    0 AS rotacion2 ,
                    0 AS ms ,
                    0 AS msxvar ,
                    0 AS faltas ,
                    0 AS incap ,
                    0 AS totAus ,
                    0 AS diaslLab ,
                    0 AS Ind_Aus ,
                    0 AS te ,
                    0 AS sueldo ,
                    0 AS porcTe ,
                    0 AS hrsTe ,
                    0 AS perEquiv ,
                    0 AS LabDiaDesc ,
                    0 AS LabDiaDescPor ,
                    0 AS hrsLabDiaDesc ,
                    0 AS grafiar       
        END
    ELSE 
        BEGIN
            DECLARE @tmp_Indicadores_Detalle_emps TABLE
                (
                  centro VARCHAR(15) ,
                  emps NUMERIC(10, 2)
                )
            DECLARE @tmp_Indicadores_Detalle_dias TABLE
                (
                  centro VARCHAR(15) ,
                  dias NUMERIC(10, 2)
                )
            DECLARE @tmp_Indicadores_Detalle_altas TABLE
                (
                  centro VARCHAR(15) ,
                  altas NUMERIC(10, 2)
                )
            DECLARE @tmp_Indicadores_Detalle_bajas TABLE
                (
                  centro VARCHAR(15) ,
                  bajas NUMERIC(10, 2)
                )
            DECLARE @tmp_Indicadores_Detalle_ms TABLE
                (
                  centro VARCHAR(15) ,
                  ms NUMERIC(10, 2) ,
                  msxvar NUMERIC(10, 2)
                )
            DECLARE @tmp_Indicadores_Detalle_ausen TABLE
                (
                  centro VARCHAR(15) ,
                  ausen NUMERIC(10, 2) ,
                  num_conc NUMERIC(4, 0)
                )
            DECLARE @tmp_Indicadores_Detalle_TExtra TABLE
                (
                  centro VARCHAR(15) ,
                  emps NUMERIC(10, 2) ,
                  nomina NUMERIC(10, 2) ,
                  horas NUMERIC(10, 2) ,
                  num_conc NUMERIC(4, 0)
                )
            PRINT '1'     	
            INSERT  INTO @tmp_Indicadores_Detalle_emps
                    ( emps ,
                      centro
                    )
                    ( SELECT    COUNT(DISTINCT ( a.codigo )) ,
                                h.valor_original
                      FROM      dbo.avisos_imss AS a
                                INNER JOIN dbo.Llaves AS L ON a.empresa = L.empresa
                                                              AND a.codigo = L.codigo
                                INNER JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                              AND a.codigo = h.codigo
                                                              AND h.campo = 'centro'
                                                              AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                                JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                      WHERE     a.mov IN ( 'A', 'IM', 'RI' )
                                AND a.fch_mov BETWEEN @fechaInicio AND @fechatermino
                                AND a.serial = 1
                                AND b.llave = @llave
                      GROUP BY  h.valor_original
                    )
                    UNION
                    ( SELECT    COUNT(DISTINCT ( a.codigo )) ,
                                l.centro
                      FROM      dbo.avisos_imss AS a
                                INNER JOIN dbo.Llaves AS L ON a.empresa = L.empresa
                                                              AND a.codigo = L.codigo
                                LEFT JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                              AND a.codigo = h.codigo
                                                              AND h.campo = 'centro'
                                                              AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                                JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                      WHERE     a.mov IN ( 'A', 'IM', 'RI' )
                                AND a.fch_mov BETWEEN @fechaInicio AND @fechatermino
                                AND H.codigo IS NULL
                                AND a.serial = 1
                                AND b.llave = @llave
                      GROUP BY  l.centro
                    )
            PRINT '2'
            INSERT  INTO @tmp_Indicadores_Detalle_dias
                    ( centro ,
                      dias
                    )
                    SELECT  h.valor_original AS centro ,
                            CASE WHEN ( SELECT  SUM(1)
                                        FROM    dbo.avisos_imss
                                        WHERE   empresa = a.empresa
                                                AND codigo = a.codigo
                                                AND fch_mov BETWEEN @fechaInicio AND @fechatermino
                                                AND mov = 'B'
                                      ) >= 1
                                      AND a.mov = 'IM' THEN 0
                                 WHEN ISNULL(( SELECT   SUM(1)
                                               FROM     dbo.avisos_imss
                                               WHERE    empresa = a.empresa
                                                        AND codigo = a.codigo
                                                        AND fch_mov BETWEEN @fechaInicio AND @fechatermino
                                                        AND mov = 'B'
                                             ), 0) = 0
                                      AND a.mov = 'IM'
                                 THEN DATEDIFF(day, a.fch_mov, @fechaTermino)
                                      + 1
                                 WHEN a.mov = 'A'
                                 THEN DATEDIFF(day, a.fch_mov, @fechaTermino)
                                 WHEN a.mov = 'RI'
                                 THEN DATEDIFF(day, a.fch_mov, @fechaTermino)
                                 WHEN a.mov = 'B'
                                 THEN DATEDIFF(day, @fechaInicio, a.fch_mov)
                                      + 1
                            END AS dias
                    FROM    dbo.avisos_imss AS a
                            INNER JOIN dbo.Llaves AS l ON a.empresa = l.empresa
                                                          AND a.codigo = l.codigo
                            INNER JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                             AND a.codigo = h.codigo
                                                             AND h.campo = 'centro'
                                                             AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                            JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                    WHERE   a.fch_mov BETWEEN @fechaInicio AND @fechatermino
                            AND a.mov <> 'MS'
                            AND b.llave = @llave
                    ORDER BY a.codigo ,
                            a.serial
            PRINT '3'	      
            INSERT  INTO @tmp_Indicadores_Detalle_dias
                    ( centro ,
                      dias
                    )
                    SELECT  l.centro ,
                            CASE WHEN ( SELECT  SUM(1)
                                        FROM    dbo.avisos_imss
                                        WHERE   empresa = a.empresa
                                                AND codigo = a.codigo
                                                AND fch_mov BETWEEN @fechaInicio AND @fechatermino
                                                AND mov = 'B'
                                      ) >= 1
                                      AND a.mov = 'IM' THEN 0
                                 WHEN ISNULL(( SELECT   SUM(1)
                                               FROM     dbo.avisos_imss
                                               WHERE    empresa = a.empresa
                                                        AND codigo = a.codigo
                                                        AND fch_mov BETWEEN @fechaInicio AND @fechatermino
                                                        AND mov = 'B'
                                             ), 0) = 0
                                      AND a.mov = 'IM'
                                 THEN DATEDIFF(day, a.fch_mov, @fechaTermino)
                                      + 1
                                 WHEN a.mov = 'A'
                                 THEN DATEDIFF(day, a.fch_mov, @fechaTermino)
                                 WHEN a.mov = 'RI'
                                 THEN DATEDIFF(day, a.fch_mov, @fechaTermino)
                                 WHEN a.mov = 'B'
                                 THEN DATEDIFF(day, @fechaInicio, a.fch_mov)
                                      + 1
                            END AS dias
                    FROM    dbo.avisos_imss AS a
                            INNER JOIN dbo.Llaves AS l ON a.empresa = l.empresa
                                                          AND a.codigo = l.codigo
                            LEFT JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                            AND a.codigo = h.codigo
                                                            AND h.campo = 'centro'
                                                            AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                            JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                    WHERE   a.fch_mov BETWEEN @fechaInicio AND @fechatermino
                            AND a.mov <> 'MS'
                            AND h.codigo IS NULL
                            AND b.llave = @llave
                    ORDER BY a.codigo ,
                            a.serial

            PRINT '4'
            INSERT  INTO @tmp_Indicadores_Detalle_altas
                    ( altas ,
                      centro
                    )
                    ( SELECT    COUNT(DISTINCT ( a.codigo )) ,
                                h.valor_original
                      FROM      dbo.avisos_imss AS a
                                INNER JOIN dbo.Llaves AS L ON a.empresa = L.empresa
                                                              AND a.codigo = L.codigo
                                INNER JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                              AND a.codigo = h.codigo
                                                              AND h.campo = 'centro'
                                                              AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                                JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                      WHERE     mov IN ( 'A' )
                                AND fch_mov BETWEEN @fechaInicio AND @fechatermino
                                AND b.llave = @llave
                      GROUP BY  h.valor_original
                    )
                    UNION
                    ( SELECT    COUNT(DISTINCT ( a.codigo )) ,
                                l.centro
                      FROM      dbo.avisos_imss AS a
                                INNER JOIN dbo.Llaves AS L ON a.empresa = L.empresa
                                                              AND a.codigo = L.codigo
                                LEFT JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                              AND a.codigo = h.codigo
                                                              AND h.campo = 'centro'
                                                              AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                                JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                      WHERE     mov IN ( 'A' )
                                AND fch_mov BETWEEN @fechaInicio AND @fechatermino
                                AND H.codigo IS NULL
                                AND b.llave = @llave
                      GROUP BY  l.centro
                    )
            PRINT '5'
            INSERT  INTO @tmp_Indicadores_Detalle_bajas
                    ( bajas ,
                      centro
                    )
                    ( SELECT    COUNT(DISTINCT ( a.codigo )) ,
                                h.valor_original
                      FROM      dbo.avisos_imss AS a
                                INNER JOIN dbo.Llaves AS L ON a.empresa = L.empresa
                                                              AND a.codigo = L.codigo
                                INNER JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                              AND a.codigo = h.codigo
                                                              AND h.campo = 'centro'
                                                              AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                                JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                      WHERE     mov IN ( 'B' )
                                AND fch_mov BETWEEN @fechaInicio AND @fechatermino
                                AND b.llave = @llave
                      GROUP BY  h.valor_original ,
                                a.fch_mov
                    )
                    UNION
                    ( SELECT    COUNT(DISTINCT ( a.codigo )) ,
                                l.centro
                      FROM      dbo.avisos_imss AS a
                                INNER JOIN dbo.Llaves AS L ON a.empresa = L.empresa
                                                              AND a.codigo = L.codigo
                                LEFT JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                              AND a.codigo = h.codigo
                                                              AND h.campo = 'centro'
                                                              AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                                JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                      WHERE     mov IN ( 'B' )
                                AND fch_mov BETWEEN @fechaInicio AND @fechatermino
                                AND H.codigo IS NULL
                                AND b.llave = @llave
                      GROUP BY  l.centro ,
                                a.fch_mov
                    )
            PRINT '6'
            INSERT  INTO @tmp_Indicadores_Detalle_ms
                    ( ms ,
                      msxvar ,
                      centro
                    )
                    ( SELECT    COUNT(a.codigo) AS Ms ,
                                COUNT(CASE WHEN a.origen = 'V' THEN 1
                                           ELSE NULL
                                      END) AS msxvar ,
                                h.valor_original
                      FROM      dbo.avisos_imss AS a
                                INNER JOIN dbo.Llaves AS L ON a.empresa = L.empresa
                                                              AND a.codigo = L.codigo
                                INNER JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                              AND a.codigo = h.codigo
                                                              AND h.campo = 'centro'
                                                              AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                                JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                      WHERE     mov IN ( 'MS' )
                                AND ( fch_mov BETWEEN @fechaInicio AND @fechatermino )
                                AND b.llave = @llave
                      GROUP BY  h.valor_original
                    )
                    UNION
                    ( SELECT    COUNT(a.codigo) AS ms ,
                                COUNT(CASE WHEN a.origen = 'V' THEN 1
                                           ELSE NULL
                                      END) AS msxvar ,
                                l.centro
                      FROM      dbo.avisos_imss AS a
                                INNER JOIN dbo.Llaves AS L ON a.empresa = L.empresa
                                                              AND a.codigo = L.codigo
                                LEFT JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                              AND a.codigo = h.codigo
                                                              AND h.campo = 'centro'
                                                              AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                                JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                      WHERE     mov IN ( 'MS' )
                                AND ( fch_mov BETWEEN @fechaInicio AND @fechatermino )
                                AND H.codigo IS NULL
                                AND b.llave = @llave
                      GROUP BY  l.centro
                    )

            PRINT '7'
            INSERT  INTO @tmp_Indicadores_Detalle_ausen
                    ( ausen ,
                      centro ,
                      num_conc
                    )
                    ( SELECT    CASE WHEN ( d.fchinicio >= @fechaInicio
                                            AND d.fchtermino <= @fechaTermino
                                          ) THEN d.dias
                                     WHEN ( d.fchinicio < @fechaInicio
                                            AND ( d.fchtermino >= @fechaInicio
                                                  AND d.fchtermino <= @fechaTermino
                                                )
                                          )
                                     THEN DATEDIFF(DAY, @fechaInicio,
                                                   d.fchtermino) + 1
                                     WHEN ( d.fchinicio < @fechaInicio
                                            AND ( d.fchtermino >= @fechaInicio
                                                  AND d.fchtermino >= @fechaTermino
                                                )
                                          ) THEN d.dias
                                     WHEN ( d.fchinicio >= @fechaInicio
                                            AND d.fchInicio <= @fechaTermino
                                          )
                                     THEN DATEDIFF(DAY, d.fchInicio,
                                                   @fechaTermino) + 1
                                END AS empalme ,
                                h.valor_original ,
                                d.num_conc
                      FROM      deducciones AS d
                                INNER JOIN llaves AS l ON l.empresa = d.empresa
                                                          AND l.codigo = d.codigo
                                INNER JOIN dbo.Historico AS h ON d.empresa = h.empresa
                                                              AND d.codigo = h.codigo
                                                              AND h.campo = 'centro'
                                                              AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                                JOIN dbo.tmpAccesoPortalPatron AS b ON d.empresa = b.empresa
                      WHERE     ( d.Num_Conc >= 108
                                  AND d.num_conc <= 111
                                )
                                AND ( ( d.fchinicio >= @fechaInicio
                                        AND d.fchtermino <= @fechaTermino
                                      )
                                      OR ( d.fchinicio < @fechaInicio
                                           AND ( d.fchtermino >= @fechaInicio
                                                 AND d.fchtermino <= @fechaTermino
                                               )
                                         )
                                      OR ( d.fchinicio < @fechaInicio
                                           AND ( d.fchtermino >= @fechaInicio
                                                 AND d.fchtermino >= @fechaTermino
                                               )
                                         )
                                      OR ( d.fchinicio >= @fechaInicio
                                           AND d.fchInicio <= @fechaTermino
                                         )
                                    )
                                AND b.llave = @llave
                    )
					--UNION 
            PRINT '8'					
            INSERT  INTO @tmp_Indicadores_Detalle_ausen
                    ( ausen ,
                      centro ,
                      num_conc
                    )
                    ( SELECT    SUM(CASE WHEN ( d.fchinicio >= @fechaInicio
                                                AND d.fchtermino <= @fechaTermino
                                              ) THEN d.dias
                                         WHEN ( d.fchinicio < @fechaInicio
                                                AND ( d.fchtermino >= @fechaInicio
                                                      AND d.fchtermino <= @fechaTermino
                                                    )
                                              )
                                         THEN DATEDIFF(DAY, @fechaInicio,
                                                       d.fchtermino) + 1
                                         WHEN ( d.fchinicio < @fechaInicio
                                                AND ( d.fchtermino >= @fechaInicio
                                                      AND d.fchtermino >= @fechaTermino
                                                    )
                                              ) THEN d.dias
                                         WHEN ( d.fchinicio >= @fechaInicio
                                                AND d.fchInicio <= @fechaTermino
                                              )
                                         THEN DATEDIFF(DAY, d.fchInicio,
                                                       @fechaTermino) + 1
                                    END) AS empalme ,
                                l.centro ,
                                CASE d.num_conc
                                  WHEN 108 THEN 108
                                  WHEN 109 THEN 109
                                  WHEN 110 THEN 109
                                  WHEN 111 THEN 109
                                  ELSE d.num_conc
                                END AS num_conc
                      FROM      deducciones AS d
                                INNER JOIN llaves AS l ON l.empresa = d.empresa
                                                          AND l.codigo = d.codigo
                                LEFT JOIN dbo.Historico AS h ON d.empresa = h.empresa
                                                              AND d.codigo = h.codigo
                                                              AND h.campo = 'centro'
                                                              AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                                JOIN dbo.tmpAccesoPortalPatron AS b ON d.empresa = b.empresa
                      WHERE     b.llave = @llave
                                AND h.codigo IS NULL
                                AND ( d.Num_Conc >= 108
                                      AND d.num_conc <= 111
                                    )
                                AND ( ( d.fchinicio >= @fechaInicio
                                        AND d.fchtermino <= @fechaTermino
                                      )
                                      OR ( d.fchinicio < @fechaInicio
                                           AND ( d.fchtermino >= @fechaInicio
                                                 AND d.fchtermino <= @fechaTermino
                                               )
                                         )
                                      OR ( d.fchinicio < @fechaInicio
                                           AND ( d.fchtermino >= @fechaInicio
                                                 AND d.fchtermino >= @fechaTermino
                                               )
                                         )
                                      OR ( d.fchinicio >= @fechaInicio
                                           AND d.fchInicio <= @fechaTermino
                                         )
                                    )
                      GROUP BY  l.centro ,
                                CASE d.num_conc
                                  WHEN 108 THEN 108
                                  WHEN 109 THEN 109
                                  WHEN 110 THEN 109
                                  WHEN 111 THEN 109
                                  ELSE d.num_conc
                                END
                    )   
            PRINT '9'
            INSERT  INTO @tmp_Indicadores_Detalle_TExtra
                    ( nomina ,
                      horas ,
                      centro ,
                      num_conc
                    )
                    SELECT  SUM(a.importe) AS nomina ,
                            SUM(a.horas) AS horas ,
                            h.valor_original AS centro ,
                            CASE a.num_conc
                              WHEN 1 THEN 1
                              WHEN 2 THEN 1
                              WHEN 3 THEN 1
                              WHEN 4 THEN 1
                              WHEN 5 THEN 1
                              WHEN 6 THEN 1
                              WHEN 11 THEN 11
                              WHEN 12 THEN 11
                              WHEN 13 THEN 11
                              ELSE a.num_conc
                            END AS num_conc
                    FROM    dbo.kardex_anual AS a
                            INNER JOIN dbo.Llaves AS L ON a.empresa = L.empresa
                                                          AND a.codigo = L.codigo
                            INNER JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                             AND a.codigo = h.codigo
                                                             AND h.campo = 'centro'
                                                             AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                            JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                    WHERE   a.num_conc IN ( 1, 2, 3, 4, 5, 6, 10, 11, 12, 13,
                                            108, 109, 110, 111 )
                            AND a.fch_pago BETWEEN @fechaInicio AND @fechatermino
                            AND a.nomina = 'ORD'
                            AND b.llave = @llave
                    GROUP BY h.valor_original ,
                            CASE a.num_conc
                              WHEN 1 THEN 1
                              WHEN 2 THEN 1
                              WHEN 3 THEN 1
                              WHEN 4 THEN 1
                              WHEN 5 THEN 1
                              WHEN 6 THEN 1
                              WHEN 11 THEN 11
                              WHEN 12 THEN 11
                              WHEN 13 THEN 11
                              ELSE a.num_conc
                            END 
            PRINT '10'			
            INSERT  INTO @tmp_Indicadores_Detalle_TExtra
                    ( nomina ,
                      horas ,
                      centro ,
                      num_conc
                    )
                    SELECT  SUM(a.importe) ,
                            SUM(a.horas) ,
                            l.centro ,
                            CASE a.num_conc
                              WHEN 1 THEN 1
                              WHEN 2 THEN 1
                              WHEN 3 THEN 1
                              WHEN 4 THEN 1
                              WHEN 5 THEN 1
                              WHEN 6 THEN 1
                              WHEN 11 THEN 11
                              WHEN 12 THEN 11
                              WHEN 13 THEN 11
                              ELSE a.num_conc
                            END AS num_conc
                    FROM    dbo.kardex_anual AS a
                            INNER JOIN dbo.Llaves AS L ON a.empresa = L.empresa
                                                          AND a.codigo = L.codigo
                            LEFT JOIN dbo.Historico AS h ON a.empresa = h.empresa
                                                            AND a.codigo = h.codigo
                                                            AND h.campo = 'centro'
                                                            AND ( h.desde BETWEEN @fechaInicio AND @fechatermino )
                            JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                    WHERE   a.num_conc IN ( 1, 2, 3, 4, 5, 6, 10, 11, 12, 13,
                                            108, 109, 110, 111 )
                            AND a.fch_pago BETWEEN @fechaInicio AND @fechatermino
                            AND H.codigo IS NULL
                            AND a.nomina = 'ORD'
                            AND b.llave = @llave
                    GROUP BY l.centro ,
                            CASE a.num_conc
                              WHEN 1 THEN 1
                              WHEN 2 THEN 1
                              WHEN 3 THEN 1
                              WHEN 4 THEN 1
                              WHEN 5 THEN 1
                              WHEN 6 THEN 1
                              WHEN 11 THEN 11
                              WHEN 12 THEN 11
                              WHEN 13 THEN 11
                              ELSE a.num_conc
                            END 
            PRINT '11'
            SELECT  a.centro AS mes ,
                    a.emps - ISNULL(b.altas, 0) AS emp_inicio_mes ,
                    a.emps - ISNULL(c.bajas, 0) AS empa_fin_mes ,
                    a.emps AS emp_totales_mes ,
                    ISNULL(b.altas, 0) AS altas ,
                    ISNULL(c.bajas, 0) AS bajas ,
                    ( ( ISNULL(b.altas, 0) - ISNULL(c.bajas, 0) ) / a.emps )
                    * 100 AS rotacion1 ,
                    ( ISNULL(c.bajas, 0) / a.emps ) * 100 AS rotacion2 ,
                    ISNULL(d.ms, 0) AS mod_salario ,
                    ISNULL(d.msxvar, 0) AS mod_salario_x_variables ,
                    ISNULL(e.ausen, 0) AS faltas ,
                    ISNULL(f.ausen, 0) AS incapacidades ,
                    ISNULL(e.ausen, 0) + ISNULL(f.ausen, 0) AS aucentismo_total ,
                    g.dias - ( ISNULL(e.ausen, 0) + ISNULL(f.ausen, 0) ) AS dias_laborados ,
                    ( ( ISNULL(e.ausen, 0) + ISNULL(f.ausen, 0) ) / ( g.dias ) )
                    * 100 AS ind_auscentismo ,
                    ISNULL(te.nomina, 0) AS tiempo_extra ,
                    ISNULL(sdo.nomina, 0) - ISNULL(pesos_aus.nomina, 0) AS sueldos ,
                    CASE ISNULL(te.nomina, 0)
                      WHEN 0 THEN 0
                      ELSE ( ISNULL(te.nomina, 0) * 100 )
                           / ( ISNULL(sdo.nomina, 0) - ISNULL(pesos_aus.nomina,
                                                              0) )
                    END AS porcentaje_tiempoextra ,
                    ISNULL(te.horas, 0) AS horas_tiempoextra ,
                    ( ISNULL(te.horas, 0) / 30.4 ) / 8 AS personal_equivalente ,
                    ISNULL(labdes.nomina, 0) AS labores_dia_descanso ,
                    CASE ISNULL(labdes.nomina, 0)
                      WHEN 0 THEN 0
                      ELSE ISNULL(labdes.nomina, 0) / ( ISNULL(sdo.nomina, 0)
                                                        - ISNULL(pesos_aus.nomina,
                                                              0) ) * 100
                    END AS porcentaje_labores_dia_descanso ,
                    ISNULL(labdes.horas, 0) AS horas_labores_dia_descanso ,
                    CASE @columnaGraficar
                      WHEN 1 THEN 0
                      WHEN 2 THEN a.emps - ISNULL(b.altas, 0)
                      WHEN 3 THEN a.emps - ISNULL(c.bajas, 0)
                      WHEN 4 THEN a.emps
                      WHEN 5 THEN ISNULL(b.altas, 0)
                      WHEN 6 THEN ISNULL(c.bajas, 0)
                      WHEN 7
                      THEN ( ( ISNULL(b.altas, 0) - ISNULL(c.bajas, 0) )
                             / a.emps ) * 100
                      WHEN 8 THEN ( ISNULL(c.bajas, 0) / a.emps ) * 100
                      WHEN 9 THEN ISNULL(d.ms, 0)
                      WHEN 10 THEN ISNULL(d.msxvar, 0)
                      WHEN 11 THEN ISNULL(e.ausen, 0)
                      WHEN 12 THEN ISNULL(f.ausen, 0)
                      WHEN 13 THEN ISNULL(e.ausen, 0) + ISNULL(f.ausen, 0)
                      WHEN 14
                      THEN g.dias - ( ISNULL(e.ausen, 0) + ISNULL(f.ausen, 0) )
                      WHEN 15
                      THEN ( ( ISNULL(e.ausen, 0) + ISNULL(f.ausen, 0) )
                             / ( g.dias ) ) * 100
                      WHEN 16 THEN ISNULL(te.nomina, 0)
                      WHEN 17
                      THEN ISNULL(sdo.nomina, 0) - ISNULL(pesos_aus.nomina, 0)
                      WHEN 18
                      THEN CASE ISNULL(te.nomina, 0)
                             WHEN 0 THEN 0
                             ELSE ( ISNULL(te.nomina, 0) * 100 )
                                  / ( ISNULL(sdo.nomina, 0)
                                      - ISNULL(pesos_aus.nomina, 0) )
                           END
                      WHEN 19 THEN ISNULL(te.horas, 0)
                      WHEN 20 THEN ( ISNULL(te.horas, 0) / 30.4 ) / 8
                      WHEN 21 THEN ISNULL(labdes.nomina, 0)
                      WHEN 22
                      THEN CASE ISNULL(labdes.nomina, 0)
                             WHEN 0 THEN 0
                             ELSE ISNULL(labdes.nomina, 0)
                                  / ( ISNULL(sdo.nomina, 0)
                                      - ISNULL(pesos_aus.nomina, 0) ) * 100
                           END
                      WHEN 23 THEN ISNULL(labdes.horas, 0)
                    END AS grafiar
            FROM    @tmp_Indicadores_Detalle_emps AS a
                    LEFT JOIN @tmp_Indicadores_Detalle_altas AS b ON a.centro = b.centro
                    LEFT JOIN @tmp_Indicadores_Detalle_bajas AS c ON a.centro = c.centro
                    LEFT JOIN @tmp_Indicadores_Detalle_ms AS d ON a.centro = d.centro
                    LEFT JOIN @tmp_Indicadores_Detalle_ausen AS e ON a.centro = e.centro
                                                              AND 108 = e.num_conc
                    LEFT JOIN @tmp_Indicadores_Detalle_ausen AS f ON a.centro = f.centro
                                                              AND 109 = f.num_conc
                    LEFT JOIN ( SELECT  centro ,
                                        SUM(dias) AS dias
                                FROM    @tmp_Indicadores_Detalle_dias
                                GROUP BY centro
                              ) AS g ON a.centro = g.centro
                    LEFT JOIN @tmp_Indicadores_Detalle_TExtra AS te ON a.centro = te.centro
                                                              AND 11 = te.num_conc
                    LEFT JOIN @tmp_Indicadores_Detalle_TExtra AS sdo ON a.centro = sdo.centro
                                                              AND 1 = sdo.num_conc
                    LEFT JOIN @tmp_Indicadores_Detalle_TExtra AS pesos_aus ON a.centro = pesos_aus.centro
                                                              AND 108 = pesos_aus.num_conc
                    LEFT JOIN @tmp_Indicadores_Detalle_TExtra AS labdes ON a.centro = labdes.centro
                                                              AND 10 = labdes.num_conc                                                                                                                                                                                                                                                                                                            
        END 
GO 
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronGetTypeGraph')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronGetTypeGraph

GO
CREATE PROCEDURE dbo.PortalPatronGetTypeGraph
    (
      @tipo udtInteger ,
      @empresa udtInteger 
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    DECLARE @recordsFound udtInteger
    SELECT  @recordsFound = COUNT(empresa)
    FROM    rhindicacng
    WHERE   empresa = @empresa
    IF @recordsFound = 0 
        INSERT  INTO dbo.rhindicacng
                ( idindicacfg ,
                  tipografica ,
                  empresa ,
                  idusuario 
                )
                SELECT  ISNULL(MAX(idindicacfg), 0) + 1 ,
                        @tipo ,
                        @empresa ,
                        0
                FROM    dbo.rhindicacng

    UPDATE  rhindicacng
    SET     tipografica = @tipo
    WHERE   empresa = @empresa        
GO

/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */ 
/*  *  *  *  *  *						Stored procedures for kardex	 		    *  *  *  *  *  *  */ 
/*  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  *  */ 
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetEmployees')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetEmployees

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetEmployees ( @llave udtLong )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    DECLARE @recordsCount udtInteger
    SELECT  @recordsCount = COUNT(empresa)
    FROM    dbo.tmpAccesoPortalPatron
    WHERE   llave = @llave

    SELECT DISTINCT
            a.activo ,
            CASE WHEN @recordsCount > 1 THEN a.afiliacion
                 ELSE CAST(a.codigo AS VARCHAR(8))
            END AS codigo ,
            a.afiliacion ,
            RTRIM(a.ap_paterno) + ' ' + RTRIM(a.ap_materno) + ' '
            + RTRIM(a.nombre) AS nombre ,
            a.curp ,
            a.rfcalfa + RTRIM(LTRIM(rfcnum)) + a.rfchomo AS rfc
    FROM    empleados AS a
            JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
    WHERE   b.llave = @llave
            AND a.borrado = 'N'
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetWorkerRequirements')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetWorkerRequirements

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetWorkerRequirements
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    
    DECLARE @recordsCount udtInteger
    
    SELECT  a.idrequisitos ,
            a.idrequisito ,
            a.Idcatalogo ,
            a.entrego ,
            b.requisito ,
            a.rutadoc
    FROM    rhrel_requisitos AS a
            JOIN rhrequisitos AS b ON b.idrequisito = a.idrequisito
            JOIN rhcatalogo AS d ON a.idcatalogo = d.idcatalogo
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    afiliacion = @afiliacion
                 ) AS h ON d.codigo = h.codigo
                           AND d.empresa = h.empresa
            JOIN dbo.tmpAccesoPortalPatron AS i ON d.empresa = i.empresa
    WHERE   i.llave = @llave                           
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetDisciplines')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetDisciplines

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetDisciplines
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  a.id ,
            b.descripcion ,
            a.fecha ,
            a.comen
    FROM    rh_diciplinas_trab AS a
            JOIN rh_diciplinas AS b ON a.iddiciplina = b.iddiciplina
            JOIN rhcatalogo AS c ON a.idcatalogo = c.idcatalogo
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    afiliacion = @afiliacion
                 ) AS h ON c.codigo = h.codigo
                           AND c.empresa = h.empresa
            JOIN dbo.tmpAccesoPortalPatron AS i ON c.empresa = i.empresa
    WHERE   i.llave = @llave
    ORDER BY a.fecha    
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetImssNotifications')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetImssNotifications

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetImssNotifications
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 ,
      @mes_operacion_ini udtInteger ,
      @mes_operacion_fin udtInteger ,
      @ayo_operacion_ini udtInteger ,
      @ayo_operacion_fin udtInteger ,
      @codigo udtInteger = 0
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    DECLARE @recordsCount udtInteger      
    DECLARE @sentenciaSql VARCHAR(8000)
    DECLARE @whereClause VARCHAR(8000)
    DECLARE @orderBy VARCHAR(1000)
    DECLARE @debugFlag AS udtBoolean
    SET @recordsCount = 0
    SET @whereClause = ''
        -- Set the debug flag
    SET @debugFlag = 0
        
    IF @ayo_operacion_ini = @ayo_operacion_fin 
        SET @whereClause = ' and ayo_operacion=' + STR(@ayo_operacion_ini)
            + ' and mes_operacion BETWEEN ' + STR(@mes_operacion_ini)
            + ' AND ' + STR(@mes_operacion_fin)
    ELSE 
        SET @whereClause = ' and ((ayo_operacion=' + STR(@ayo_operacion_ini)
            + ' and mes_operacion BETWEEN ' + STR(@mes_operacion_ini)
            + ' AND 12 ) or ' + ' (ayo_operacion=' + STR(@ayo_operacion_fin)
            + ' and mes_operacion BETWEEN 1 ' + ' AND '
            + STR(@mes_operacion_fin) + ') or (ayo_operacion>'
            + STR(@ayo_operacion_ini) + ' and ayo_operacion<'
            + STR(@ayo_operacion_fin) + '))'

    SET @sentenciaSql = 'SELECT  COUNT(a.empresa)
    FROM    avisos_imss AS a
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    (afiliacion = ''' + @afiliacion + ''' AND LEN(ltrim(''' + @afiliacion + '''))>0) OR (LEN(ltrim(''' + @afiliacion + '''))=0 AND codigo='+STR(@codigo)+')    
                 ) AS h ON a.codigo = h.codigo
                           AND a.empresa = h.empresa
            JOIN dbo.tmpAccesoPortalPatron AS i ON a.empresa = i.empresa
    WHERE   i.llave = ' + STR(@llave)
    
    CREATE TABLE #ViewPortalKardexCounter ( TotalRecords INTEGER )
    IF @debugFlag = 1 
        SELECT  @sentenciaSql + @whereClause       
    ELSE 
        INSERT  INTO #ViewPortalKardexCounter
                EXECUTE ( @sentenciaSql + @whereClause
                       )
    SELECT TOP 1
            @recordsCount = TotalRecords
    FROM    #ViewPortalKardexCounter
    SET @recordsCount = ISNULL(@recordsCount, 0)
        
    DROP TABLE #ViewPortalKardexCounter

    SET @sentenciaSql = 'SELECT  a.empresa ,
            a.codigo ,
            a.serial ,
            a.mes_operacion ,
            a.ayo_operacion ,
            a.fch_mov ,
            a.fch_real ,
            a.mov ,
            a.sueldo ,
            a.saldiaint ,
            a.diastr ,
            isnull(a.incap,0) as incap ,
            isnull(a.ausen,0) as ausen,
            a.origen
    FROM    avisos_imss AS a
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    (afiliacion = ''' + @afiliacion + ''' AND LEN(ltrim(''' + @afiliacion + '''))>0) OR (LEN(ltrim(''' + @afiliacion + '''))=0 AND codigo='+STR(@codigo)+')    
                 ) AS h ON a.codigo = h.codigo
                           AND a.empresa = h.empresa
            JOIN dbo.tmpAccesoPortalPatron AS i ON a.empresa = i.empresa
    WHERE   i.llave = ' + STR(@llave)

/*			AND a.mes_operacion >= @mes_operacion_ini
            AND a.mes_operacion <= @mes_operacion_fin
            AND a.ayo_operacion >= @ayo_operacion_ini
            AND a.ayo_operacion <= @ayo_operacion_fin
*/
    SET @orderBy = ' ORDER BY fch_mov ,
            serial '
    IF @debugFlag = 1 
        SELECT  @sentenciaSql + @whereClause       
    ELSE 
        IF @recordsCount > 0 
            EXECUTE ( @sentenciaSql + @whereClause+@orderBy)                   
        ELSE 
            SELECT  0 AS empresa ,
                    0 AS codigo ,
                    0 AS serial ,
                    0 AS mes_operacion ,
                    0 AS ayo_operacion ,
                    NULL AS fch_mov ,
                    0 AS fch_real ,
                    0 AS mov ,
                    0 AS sueldo ,
                    0 AS saldiaint ,
                    0 AS diastr ,
                    0 AS incap ,
                    0 AS ausen ,
                    0 AS origen
	
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetKardexEmployee')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetKardexEmployee
GO
CREATE PROCEDURE dbo.PortalPatronKardexGetKardexEmployee
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 ,
      @mes_operacion_ini udtInteger ,
      @mes_operacion_fin udtInteger ,
      @ayo_operacion_ini udtInteger ,
      @ayo_operacion_fin udtInteger ,
      @filtro AS VARCHAR(2) ,
      @detalle AS VARCHAR(3),
      @codigo udtInteger = 0
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    DECLARE @recordsCount udtInteger
    DECLARE @sentenciaSql VARCHAR(8000)
    DECLARE @whereClause VARCHAR(8000)
    DECLARE @orderBy VARCHAR(1000)
    DECLARE @groupBy VARCHAR(1000)
    DECLARE @debugFlag AS udtBoolean
    SET @recordsCount = 0
    SET @whereClause = ''
    SET @groupBy = ''
-- Set the debug flag
    SET @debugFlag = 0
-- Si se modifica algo del where tambien hay que modifiacar el PortalPatronKardexGetKardexEmployeeTotals

    IF @ayo_operacion_ini = @ayo_operacion_fin 
        SET @whereClause = ' and ayo_operacion=' + STR(@ayo_operacion_ini)
            + ' and MONTH(fch_pago) BETWEEN ' + STR(@mes_operacion_ini)
            + ' AND ' + STR(@mes_operacion_fin)
    ELSE 
        SET @whereClause = ' and ((ayo_operacion=' + STR(@ayo_operacion_ini)
            + ' and MONTH(fch_pago) BETWEEN ' + STR(@mes_operacion_ini)
            + ' AND 12 ) or ' + ' (ayo_operacion=' + STR(@ayo_operacion_fin)
            + ' and MONTH(fch_pago) BETWEEN 1 ' + ' AND '
            + STR(@mes_operacion_fin) + ') or (ayo_operacion>'
            + STR(@ayo_operacion_ini) + ' and ayo_operacion<'
            + STR(@ayo_operacion_fin) + '))'

    IF @filtro = 'V' 
        SET @whereClause = @whereClause + ' AND a.num_conc=30'
    ELSE 
        IF @filtro = 'A' 
            SET @whereClause = @whereClause
                + ' AND a.num_conc in (108,109,110,111)'

    IF @detalle = 'Tot' 
        BEGIN
            SET @sentenciaSql = ' SELECT COUNT(*) FROM (SELECT  a.num_conc                                        
FROM    kardex_anual AS a
JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
JOIN ( SELECT   codigo ,
empresa
FROM     dbo.empleados
WHERE    (afiliacion = ''' + @afiliacion + ''' AND LEN(ltrim(''' + @afiliacion + '''))>0) OR (LEN(ltrim(''' + @afiliacion + '''))=0 AND codigo='+STR(@codigo)+')
) AS h ON a.codigo = h.codigo
AND a.empresa = h.empresa
WHERE  llave=' + STR(@llave) + ' and num_conc > 0
AND num_conc < 200 ' + @whereClause + ' GROUP BY a.num_conc  ) AS a'

        END
    ELSE 
        BEGIN 
            SET @sentenciaSql = 'SELECT  COUNT(a.ayo_operacion)
FROM    kardex_anual AS a
JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
JOIN ( SELECT   codigo ,
empresa
FROM     dbo.empleados
WHERE    (afiliacion = ''' + @afiliacion + ''' AND LEN(ltrim(''' + @afiliacion + '''))>0) OR (LEN(ltrim(''' + @afiliacion + '''))=0 AND codigo='+STR(@codigo)+')
) AS h ON a.codigo = h.codigo
AND a.empresa = h.empresa
WHERE  llave=' + STR(@llave) + ' and num_conc > 0
AND num_conc < 200 ' + @whereClause 
        END
    CREATE TABLE #ViewPortalKardexCounter ( TotalRecords INTEGER )
    IF @debugFlag = 1 
        SELECT  @sentenciaSql 
    ELSE 
        INSERT  INTO #ViewPortalKardexCounter
                EXECUTE ( @sentenciaSql
                       )
    SELECT TOP 1
            @recordsCount = TotalRecords
    FROM    #ViewPortalKardexCounter
    SET @recordsCount = ISNULL(@recordsCount, 0)

    DROP TABLE #ViewPortalKardexCounter

    IF @detalle = 'Tot' 
        BEGIN
            SET @sentenciaSql = 'SELECT  a.num_conc, a.concepto, SUM(a.importe) as importe,
        SUM(ISNULL(a.dias, 0)) AS dias ,
        SUM(a.igravable) AS igravable ,
        SUM(a.iexento) AS iexento,
        SUM(ISNULL(a.variaimss, 0)) AS variaimss ,
        SUM(ISNULL(a.horas, 0)) AS horas
FROM    kardex_anual AS a
JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
JOIN ( SELECT   codigo ,
empresa
FROM     dbo.empleados
WHERE    (afiliacion = ''' + @afiliacion + ''' AND LEN(ltrim(''' + @afiliacion + '''))>0) OR (LEN(ltrim(''' + @afiliacion + '''))=0 AND codigo='+STR(@codigo)+')
) AS h ON a.codigo = h.codigo
AND a.empresa = h.empresa
WHERE llave=' + STR(@llave) + ' and num_conc > 0
AND num_conc < 200'
            SET @orderBy = ' ORDER BY a.num_conc '
            SET @groupBy = ' Group BY a.num_conc,a.concepto'
        END
    ELSE 
        BEGIN
            SET @sentenciaSql = 'SELECT  a.ayo_operacion, a.periodo, a.num_conc, a.concepto, a.importe, a.nomina, a.fch_inicio, a.fch_cierre ,
a.fch_pago, isnull(a.dias,0) as dias, a.referencia, a.igravable, a.iexento, isnull(a.variaimss,0) as variaimss, ISNULL(a.horas, 0) AS horas
FROM    kardex_anual AS a
JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
JOIN ( SELECT   codigo ,
empresa
FROM     dbo.empleados
WHERE    (afiliacion = ''' + @afiliacion + ''' AND LEN(ltrim(''' + @afiliacion + '''))>0) OR (LEN(ltrim(''' + @afiliacion + '''))=0 AND codigo='+STR(@codigo)+')
) AS h ON a.codigo = h.codigo
AND a.empresa = h.empresa
WHERE llave=' + STR(@llave) + ' and num_conc > 0
AND num_conc < 200'
            SET @orderBy = ' ORDER BY a.ayo_operacion, a.periodo, a.num_conc '
        END

    IF @debugFlag = 1 
        SELECT  @sentenciaSql + @whereClause + @groupBy + @orderBy
    ELSE 
        IF @recordsCount > 0 
            EXECUTE ( @sentenciaSql + @whereClause+@groupBy+@orderBy)
        ELSE 
            SELECT  0 AS ayo_operacion ,
                    0 AS periodo ,
                    0 AS num_conc ,
                    '' AS concepto ,
                    0 AS importe ,
                    0 AS nomina ,
                    '' AS fch_inicio ,
                    '' AS fch_cierre ,
                    '' AS fch_pago ,
                    0 AS dias ,
                    '' AS referencia ,
                    0 AS igravable ,
                    0 AS iexento ,
                    0 AS variaimss ,
                    0 AS horas
GO 
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetVacationsEmployee')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetVacationsEmployee

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetVacationsEmployee
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  disfruto ,
            dias_tab ,
            dias_saldo
    FROM    vacaciones AS a
            JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    afiliacion = @afiliacion
                 ) AS h ON a.codigo = h.codigo
                           AND a.empresa = h.empresa
    WHERE   b.llave = @llave              
GO         
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetHistoryTab')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetHistoryTab

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetHistoryTab
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  a.campo ,
            ISNULL(c.actividad, d.nomdepto) AS nombre ,
            a.folio ,
            a.codigo
    FROM    historico AS a
            LEFT JOIN tabulador AS c ON a.valor_original = c.ocupacion
                                        AND a.empresa = c.empresa
            LEFT JOIN centros AS d ON a.empresa = d.empresa
                                      AND a.valor_original = d.centro
            JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    afiliacion = @afiliacion
                 ) AS h ON a.codigo = h.codigo
                           AND a.empresa = h.empresa
    WHERE   b.llave = @llave
            AND ( a.campo = 'TABULADOR'
                  OR a.campo = 'centro'
                )
    ORDER BY a.folio DESC              
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetEmployeeFamily')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetEmployeeFamily

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetEmployeeFamily
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  a.Idcatalogo ,
            a.nombre ,
            b.parentesco
    FROM    rhfamiliar AS a
            LEFT JOIN rhparentesco AS b ON a.idparentesco = b.idparentesco
            JOIN rhcatalogo AS c ON a.Idcatalogo = c.Idcatalogo
            JOIN dbo.tmpAccesoPortalPatron AS g ON c.empresa = g.empresa
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    afiliacion = @afiliacion
                 ) AS h ON c.codigo = h.codigo
                           AND c.empresa = h.empresa
    WHERE   g.llave = @llave            
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetEmployeeLanguages')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetEmployeeLanguages

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetEmployeeLanguages
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 ,
      @codigo udtinteger = 0
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    DECLARE @recordsCount AS udtinteger
    SET @recordsCount = 0
	
    SELECT  @recordsCount = COUNT(cat.rhIdioma)
    FROM    rhidioma a
            JOIN rhcat_idio AS cat ON a.idcat_Idio = cat.idcat_Idio
            JOIN rhsolicita AS sol ON a.idsolicitudes = Sol.idsolicitudes
            JOIN rhcatalogo AS cta ON sol.idcatalogo = cta.idcatalogo
            JOIN dbo.tmpAccesoPortalPatron AS g ON cta.empresa = g.empresa
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    (afiliacion = @afiliacion AND LEN(ltrim(@afiliacion))>0) OR (LEN(ltrim(@afiliacion))=0 AND codigo=@codigo)
                 ) AS h ON cta.codigo = h.codigo
                           AND cta.empresa = h.empresa
    WHERE   g.llave = @llave                        
	
    IF @recordsCount > 0 
        SELECT  cat.rhIdioma ,
                a.habla ,
                a.escribe ,
                a.lee ,
                a.intituto ,
                a.per_ini ,
                a.per_Fin ,
                a.ididioma ,
                a.idcat_Idio ,
                a.idsolicitudes
        FROM    rhidioma a
                JOIN rhcat_idio AS cat ON a.idcat_Idio = cat.idcat_Idio
                JOIN rhsolicita AS sol ON a.idsolicitudes = Sol.idsolicitudes
                JOIN rhcatalogo AS cta ON sol.idcatalogo = cta.idcatalogo
                JOIN dbo.tmpAccesoPortalPatron AS g ON cta.empresa = g.empresa
                JOIN ( SELECT   codigo ,
                                empresa
                       FROM     dbo.empleados
                       WHERE    (afiliacion = @afiliacion AND LEN(ltrim(@afiliacion))>0) OR (LEN(ltrim(@afiliacion))=0 AND codigo=@codigo)
                     ) AS h ON cta.codigo = h.codigo
                               AND cta.empresa = h.empresa
        WHERE   g.llave = @llave                        
    ELSE 
        SELECT  '' AS rhIdioma ,
                0 AS habla ,
                0 AS escribe ,
                0 AS lee ,
                '' AS intituto ,
                0 AS per_ini ,
                0 AS per_Fin ,
                0 AS ididioma ,
                0 AS idcat_Idio ,
                0 AS idsolicitudes
		
		
GO         

IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetEmployeeEducationalLevel')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetEmployeeEducationalLevel

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetEmployeeEducationalLevel
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 ,
      @codigo udtInteger = 0
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    DECLARE @recordsCount AS udtinteger
    SET @recordsCount = 0
    SELECT  @recordsCount = COUNT(b.nivel)
    FROM    rhestudios AS a
            LEFT JOIN rhnivel AS b ON a.idnivel = b.idnivel
            LEFT JOIN rhcarreras AS c ON a.idcarreras = c.idcarreras
            LEFT JOIN rhSolicita AS s ON a.idsolicitudes = s.idsolicitudes
            JOIN rhcatalogo AS d ON s.idcatalogo = d.idcatalogo
            JOIN dbo.tmpAccesoPortalPatron AS g ON d.empresa = g.empresa
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    (afiliacion = @afiliacion AND LEN(ltrim(@afiliacion))>0) OR (LEN(ltrim(@afiliacion))=0 AND codigo=@codigo)
                 ) AS h ON d.codigo = h.codigo
                           AND d.empresa = h.empresa
    WHERE   g.llave = @llave              
    
    IF @recordsCount > 0 
        SELECT  b.nivel ,
                c.carrera ,
                CASE a.comprueba
                  WHEN 1 THEN 'DIPLOMA'
                  WHEN 2 THEN 'CONSTANCIA'
                  WHEN 3 THEN 'CERTIFICADO'
                  WHEN 4 THEN 'CARTA DE PASANTE'
                  WHEN 5 THEN 'TITULO'
                  WHEN 6 THEN 'NINGUNO'
                  WHEN 7 THEN 'CARRERA TRUNCA'
                  ELSE ''
                END AS Comprobante ,
                a.poblacion ,
                a.anioinicial ,
                a.aniofinal ,
                a.idestudios ,
                a.idescuela ,
                a.idcarreras ,
                a.idnivel ,
                a.idsolicitudes ,
                a.comprueba ,
                a.anioinicial ,
                a.aniofinal
        FROM    rhestudios AS a
                LEFT JOIN rhnivel AS b ON a.idnivel = b.idnivel
                LEFT JOIN rhcarreras AS c ON a.idcarreras = c.idcarreras
                LEFT JOIN rhSolicita AS s ON a.idsolicitudes = s.idsolicitudes
                JOIN rhcatalogo AS d ON s.idcatalogo = d.idcatalogo
                JOIN dbo.tmpAccesoPortalPatron AS g ON d.empresa = g.empresa
                JOIN ( SELECT   codigo ,
                                empresa
                       FROM     dbo.empleados
                       WHERE    (afiliacion = @afiliacion AND LEN(ltrim(@afiliacion))>0) OR (LEN(ltrim(@afiliacion))=0 AND codigo=@codigo)
                     ) AS h ON d.codigo = h.codigo
                               AND d.empresa = h.empresa
        WHERE   g.llave = @llave              
    ELSE 
        SELECT  '' AS nivel ,
                '' AS carrera ,
                '' AS Comprobante ,
                '' AS poblacion ,
                0 AS anioinicial ,
                0 AS aniofinal ,
                0 AS idestudios ,
                0 AS idescuela ,
                0 AS idcarreras ,
                0 AS idnivel ,
                0 AS idsolicitudes ,
                0 AS comprueba ,
                0 AS anioinicial ,
                0 AS aniofinal
GO    
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetEmployeePsychologicalTests')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetEmployeePsychologicalTests

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetEmployeePsychologicalTests
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  a.idcat_psc ,
            b.nombre ,
            a.calificacion
    FROM    rhrel_cat_psc AS a
            LEFT JOIN rhpsicologo AS b ON a.idpsicologo = b.idpsicologo
            JOIN rhcatalogo AS d ON a.idcatalogo = d.idcatalogo
            JOIN dbo.tmpAccesoPortalPatron AS g ON d.empresa = g.empresa
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    afiliacion = @afiliacion
                 ) AS h ON d.codigo = h.codigo
                           AND d.empresa = h.empresa
    WHERE   g.llave = @llave              
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetEmployeeCoursesTaken')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetEmployeeCoursesTaken

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetEmployeeCoursesTaken
    (
      @llave udtLong ,
      @afiliacion udtStringSize15,
      @codigo udtinteger =0
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    DECLARE @recordsCount AS udtinteger
    SET @recordsCount = 0
    SELECT  @recordsCount = COUNT(a.empresa)
    FROM    capa_empleadoprogramacion AS a
            LEFT JOIN capa_programacion AS b ON a.idprogramacion = b.idprogramacion
            LEFT JOIN capa_curso AS c ON b.idcurso = c.idcurso
            JOIN dbo.tmpAccesoPortalPatron AS g ON a.empresa = g.empresa
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    (afiliacion = @afiliacion AND LEN(ltrim(@afiliacion))>0) OR (LEN(ltrim(@afiliacion))=0 AND codigo=@codigo)
                 ) AS h ON a.codigo = h.codigo
                           AND a.empresa = h.empresa
    WHERE   g.llave = @llave                
    IF @recordsCount > 0 
        SELECT  a.empresa ,
                a.codigo ,
                c.nombre ,
                a.calificacion ,
                b.ffinal ,
                a.idprogramacion ,
                a.asistencia ,
                a.comentarios
        FROM    capa_empleadoprogramacion AS a
                LEFT JOIN capa_programacion AS b ON a.idprogramacion = b.idprogramacion
                LEFT JOIN capa_curso AS c ON b.idcurso = c.idcurso
                JOIN dbo.tmpAccesoPortalPatron AS g ON a.empresa = g.empresa
                JOIN ( SELECT   codigo ,
                                empresa
                       FROM     dbo.empleados
                       WHERE    (afiliacion = @afiliacion AND LEN(ltrim(@afiliacion))>0) OR (LEN(ltrim(@afiliacion))=0 AND codigo=@codigo)
                     ) AS h ON a.codigo = h.codigo
                               AND a.empresa = h.empresa
        WHERE   g.llave = @llave                
    ELSE 
        SELECT  0 AS empresa ,
                0 AS codigo ,
                '' AS nombre ,
                0 AS calificacion ,
                '' AS ffinal ,
                0 AS idprogramacion ,
                '' AS asistencia ,
                '' AS comentarios
		
GO   
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetEmployeeData')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetEmployeeData

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetEmployeeData
    (
      @llave udtLong ,
      @afiliacion udtStringSize15,
      @codigo udtInteger = 0
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON
    SELECT  CASE a.activo
              WHEN 'S' THEN 'ACTIVO'
              WHEN 'N' THEN 'BAJA'
              ELSE ''
            END AS activo ,
            a.empresa ,
            a.codigo ,
            a.fchalta ,
            a.fchantigua ,
            e.nomina ,
            a.tiposal ,
            CASE a.sindicato
              WHEN 'S' THEN 'SINDICALIZADO'
              WHEN 'C' THEN 'CONFIANZA'
              ELSE ''
            END AS Sindicato ,
            f.actividad ,
            d.nombre AS hora ,
            g.nomdepto ,
            a.afiliacion ,
            a.digvera ,
            a.rfcalfa ,
            a.rfcnum ,
            a.rfchomo ,
            a.fchnac ,
            a.edonac ,
            CASE a.sexo
              WHEN 'M' THEN 'MASCULINO'
              WHEN 'F' THEN 'FEMENINO'
              ELSE ''
            END AS Sexo ,
            a.curp ,
            b.domicilio ,
            b.colonia ,
            b.poblacion ,
            b.codpostal ,
            b.telefono ,
            c.tiponom ,
            DATEDIFF(year, a.fchantigua, GETDATE()) AS antigua ,
            a.ap_paterno ,
            a.ap_materno ,
            a.nombre ,
            a.ultmov ,
            a.sueldo ,
            a.saldiaint ,
            j.numcredito ,
            CASE j.tipo_cred
              WHEN 1 THEN '1.-PORCENTAJE'
              WHEN 2 THEN '2.-CUOTA FIJA'
              WHEN 3 THEN '3.-VECES EN SALARIO MINIMO'
              ELSE ''
            END AS tipo_cred ,
            j.descuento ,
            j.fch_otorga ,
            j.fecha ,
            j.amortizacion_retenido,
            ISNULL(l.nombre,'') AS padre,
            ISNULL(m.nombre,'') AS madre,
            b.foto
    FROM    empleados AS a
            LEFT JOIN datosemps AS b ON a.empresa = b.empresa
                                        AND a.codigo = b.codigo
            LEFT JOIN llaves AS c ON a.empresa = c.empresa
                                     AND a.codigo = c.codigo
            LEFT JOIN horarios_catalogo AS d ON c.empresa = d.empresa
                                                AND c.horario = d.Horario
            LEFT JOIN nominas AS e ON c.empresa = e.empresa
                                      AND c.tiponom = e.tiponom
            LEFT JOIN tabulador AS f ON c.empresa = f.empresa
                                        AND c.ocupacion = f.ocupacion
            LEFT JOIN centros AS g ON c.empresa = g.empresa
                                      AND c.centro = g.centro
            JOIN ( SELECT   codigo ,
                            empresa
                   FROM     dbo.empleados
                   WHERE    (afiliacion = @afiliacion AND LEN(ltrim(@afiliacion))>0) OR (LEN(ltrim(@afiliacion))=0 AND codigo=@codigo)
                 ) AS h ON a.codigo = h.codigo
                           AND a.empresa = h.empresa
            JOIN dbo.tmpAccesoPortalPatron AS i ON a.empresa = i.empresa
            LEFT JOIN dbo.infonavit AS j ON a.empresa = j.empresa
                                            AND a.codigo = j.codigo
            LEFT JOIN rhcatalogo AS k ON a.codigo=k.codigo AND a.empresa=k.empresa
            LEFT JOIN rhfamiliar AS l ON k.Idcatalogo=l.Idcatalogo AND 1=l.idparentesco
            LEFT JOIN rhfamiliar AS m ON k.Idcatalogo=m.Idcatalogo AND 2=m.idparentesco
    WHERE   i.llave = @llave
GO
IF EXISTS ( SELECT  *
            FROM    dbo.sysobjects
            WHERE   id = OBJECT_ID(N'dbo.PortalPatronKardexGetKardexEmployeeTotals')
                    AND OBJECTPROPERTY(id, N'IsProcedure') = 1 ) 
    DROP PROCEDURE dbo.PortalPatronKardexGetKardexEmployeeTotals

GO
CREATE PROCEDURE dbo.PortalPatronKardexGetKardexEmployeeTotals
    (
      @llave udtLong ,
      @afiliacion udtStringSize15 ,
      @mes_operacion_ini udtInteger ,
      @mes_operacion_fin udtInteger ,
      @ayo_operacion_ini udtInteger ,
      @ayo_operacion_fin udtInteger ,
      @filtro AS VARCHAR(2) ,
      @detalle AS VARCHAR(3)
    )
    WITH ENCRYPTION
AS 
    SET NOCOUNT ON

    DECLARE @recordsCount udtInteger      
    DECLARE @sentenciaSql VARCHAR(8000)
    DECLARE @whereClause VARCHAR(8000)
    DECLARE @orderBy VARCHAR(1000)
    DECLARE @groupBy VARCHAR(1000)
    DECLARE @debugFlag AS udtBoolean
    SET @recordsCount = 0
    SET @whereClause = ''
    SET @groupBy = ''
        -- Set the debug flag
    SET @debugFlag = 0
    
    
    IF @ayo_operacion_ini = @ayo_operacion_fin 
        SET @whereClause = ' and ayo_operacion=' + STR(@ayo_operacion_ini)
            + ' and MONTH(fch_pago) BETWEEN ' + STR(@mes_operacion_ini)
            + ' AND ' + STR(@mes_operacion_fin)
    ELSE 
        SET @whereClause = ' and ((ayo_operacion=' + STR(@ayo_operacion_ini)
            + ' and MONTH(fch_pago) BETWEEN ' + STR(@mes_operacion_ini)
            + ' AND 12 ) or ' + ' (ayo_operacion=' + STR(@ayo_operacion_fin)
            + ' and MONTH(fch_pago) BETWEEN 1 ' + ' AND '
            + STR(@mes_operacion_fin) + ') or (ayo_operacion>'
            + STR(@ayo_operacion_ini) + ' and ayo_operacion<'
            + STR(@ayo_operacion_fin) + '))'

    IF @filtro = 'V' 
        SET @whereClause = @whereClause + ' AND a.num_conc=30'
    ELSE 
        IF @filtro = 'A' 
            SET @whereClause = @whereClause
                + ' AND a.num_conc in (108,109,110,111)'
	SET @groupBy=' GROUP BY a.num_conc ORDER BY a.num_conc'

    DECLARE @ViewPortalKardexTotals TABLE
        (
          num_conc INTEGER ,
          importe NUMERIC(10, 2) ,
          serial INTEGER
        )

    SET @sentenciaSql = ' SELECT  a.num_conc ,
                    SUM(a.importe) ,
                    ROW_NUMBER() OVER ( ORDER BY num_conc ASC )
            FROM    kardex_anual AS a
                    JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                    JOIN ( SELECT   codigo ,
                                    empresa
                           FROM     dbo.empleados
                           WHERE    afiliacion = '''+@afiliacion+'''
                         ) AS h ON a.codigo = h.codigo
                                   AND a.empresa = h.empresa
            WHERE   llave = '+STR(@llave)+'
                    AND num_conc > 0
                    AND num_conc < 100 '
     IF @debugFlag=1
        SELECT @sentenciaSql + @whereClause + @groupBy
     else   
		INSERT  INTO @ViewPortalKardexTotals ( num_conc ,importe , serial )                    
		EXECUTE ( @sentenciaSql + @whereClause + @groupBy)    

    SET @sentenciaSql = 'SELECT  a.num_conc ,
                    SUM(a.importe) ,
                    ROW_NUMBER() OVER ( ORDER BY num_conc ASC )
            FROM    kardex_anual AS a
                    JOIN dbo.tmpAccesoPortalPatron AS b ON a.empresa = b.empresa
                    JOIN ( SELECT   codigo ,
                                    empresa
                           FROM     dbo.empleados
                           WHERE    afiliacion = '''+@afiliacion+'''
                         ) AS h ON a.codigo = h.codigo
                                   AND a.empresa = h.empresa
            WHERE   llave = '+STR(@llave)+'
                    AND num_conc > 100
                    AND num_conc < 200 '  
     IF @debugFlag=1
        SELECT @sentenciaSql + @whereClause + @groupBy
     else               
		INSERT  INTO @ViewPortalKardexTotals( num_conc,importe,serial)            
			EXECUTE ( @sentenciaSql + @whereClause + @groupBy )

    SELECT  DISTINCT
            ( a.serial ) ,
            b.num_conc ,
            b.importe ,
            c.num_conc ,
            c.importe
    FROM    @ViewPortalKardexTotals AS a
            LEFT JOIN @ViewPortalKardexTotals AS b ON a.serial = b.serial
                                                      AND b.num_conc < 100
            LEFT JOIN @ViewPortalKardexTotals AS c ON a.serial = c.serial
                                                      AND c.num_conc > 100
go               
PRINT 'Listo'
GO